Debian Bug report logs - #679597
apparmor: AppArmor totally broken

version graph

Package: apparmor; Maintainer for apparmor is Kees Cook <kees@debian.org>; Source for apparmor is src:apparmor.

Reported by: intrigeri@debian.org

Date: Sat, 30 Jun 2012 02:57:02 UTC

Severity: grave

Tags: patch

Found in versions apparmor/2.7.103-3, apparmor/2.7.103-2

Fixed in version apparmor/2.7.103-4

Done: Kees Cook <kees@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, john.johansen@canonical.com, kees@debian.org, micah@riseup.net, Kees Cook <kees@debian.org>:
Bug#679597; Package apparmor. (Sat, 30 Jun 2012 02:57:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to intrigeri@debian.org:
New Bug report received and forwarded. Copy sent to john.johansen@canonical.com, kees@debian.org, micah@riseup.net, Kees Cook <kees@debian.org>. (Sat, 30 Jun 2012 02:57:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: intrigeri@debian.org
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: apparmor: AppArmor totally broken
Date: Sat, 30 Jun 2012 04:54:44 +0200
Package: apparmor
Version: 2.7.103-3
Severity: grave
X-Debbugs-CC: john.johansen@canonical.com, kees@debian.org, micah@riseup.net

Hi,

(following-up on #676515)

John Johansen wrote (26 Jun 2012 17:48:38 GMT) :
> Okay, there are 4 kernel patches, not all of them are needed depending on whether
> the network patch is applied or not.

> If you don't want to apply the networking patch
>   0001-apparmor-remove-advertising-the-support-of-network-r.patch

>   Stops the kernel interface from incorrectly advertising that it
>   supports network rules. A further patch (not attached) to
>   userspace will also have to be applied

Thanks, John, for your work on this.

For those who did not follow the entire saga, this patch was applied
in the linux 3.2.21-3 source package, to complement the incomplete
AppArmor compatibility patch, so Debian bug #676515 was closed,
as the kernel side is now sorted out. So far, so good.

However, as expected, this is not enough to make AppArmor usable, so
the current state in current sid is still a regression compared to
when the compatibility patch was not applied to the kernel: it used to
be bad, but relatively usable, and it's now totally unusable.

This bug is here to track the additional patch against userspace,
that John mentioned was needed, which is confirmed by my experience.




Information forwarded to debian-bugs-dist@lists.debian.org, Kees Cook <kees@debian.org>:
Bug#679597; Package apparmor. (Sat, 30 Jun 2012 07:48:24 GMT) Full text and rfc822 format available.

Acknowledgement sent to John Johansen <john.johansen@canonical.com>:
Extra info received and forwarded to list. Copy sent to Kees Cook <kees@debian.org>. (Sat, 30 Jun 2012 07:48:24 GMT) Full text and rfc822 format available.

Message #10 received at submit@bugs.debian.org (full text, mbox):

From: John Johansen <john.johansen@canonical.com>
To: intrigeri@debian.org, 679597@bugs.debian.org
Cc: Debian Bug Tracking System <submit@bugs.debian.org>, Kees Cook <kees@ubuntu.com>
Subject: Re: Bug#679597: apparmor: AppArmor totally broken
Date: Sat, 30 Jun 2012 00:30:20 -0700
On 06/29/2012 07:54 PM, intrigeri@debian.org wrote:
> Package: apparmor
> Version: 2.7.103-3
> Severity: grave
> X-Debbugs-CC: john.johansen@canonical.com, kees@debian.org, micah@riseup.net
> 
> Hi,
> 
> (following-up on #676515)
> 
> John Johansen wrote (26 Jun 2012 17:48:38 GMT) :
>> Okay, there are 4 kernel patches, not all of them are needed depending on whether
>> the network patch is applied or not.
> 
>> If you don't want to apply the networking patch
>>   0001-apparmor-remove-advertising-the-support-of-network-r.patch
> 
>>   Stops the kernel interface from incorrectly advertising that it
>>   supports network rules. A further patch (not attached) to
>>   userspace will also have to be applied
> 
> Thanks, John, for your work on this.
> 
> For those who did not follow the entire saga, this patch was applied
> in the linux 3.2.21-3 source package, to complement the incomplete
> AppArmor compatibility patch, so Debian bug #676515 was closed,
> as the kernel side is now sorted out. So far, so good.
> 
> However, as expected, this is not enough to make AppArmor usable, so
> the current state in current sid is still a regression compared to
> when the compatibility patch was not applied to the kernel: it used to
> be bad, but relatively usable, and it's now totally unusable.
> 
> This bug is here to track the additional patch against userspace,
> that John mentioned was needed, which is confirmed by my experience.
> 
> 

Sorry I meant to have attached this patch already as a separate comment
when I posted the kernel patches.

---

Fix the parser so it checks for the presence of the network feature in the
compatibility interface. Previously it was assuming that if the compatibility
interface was present that network rules where also present, this is not
necessarily true and causes apparmor to break when only the compatibility
patch is applied.

Signed-off-by: John Johansen <john.johansen@canonical.com>

=== modified file 'parser/parser_main.c'
--- parser/parser_main.c	2012-04-11 23:03:21 +0000
+++ parser/parser_main.c	2012-06-30 06:31:05 +0000
@@ -873,6 +873,11 @@
 //fprintf(stderr, "flags string: %s\n", flags_string);
 //fprintf(stderr, "changehat %d\n", flag_changehat_version);
 	}
+	if (strstr(flags_string, "network"))
+		kernel_supports_network = 1;
+	else
+		kernel_supports_network = 0;
+
 	return;
 
 fail:




Information forwarded to debian-bugs-dist@lists.debian.org, Kees Cook <kees@debian.org>:
Bug#679597; Package apparmor. (Sat, 30 Jun 2012 07:48:43 GMT) Full text and rfc822 format available.

Acknowledgement sent to John Johansen <john.johansen@canonical.com>:
Extra info received and forwarded to list. Copy sent to Kees Cook <kees@debian.org>. (Sat, 30 Jun 2012 07:48:44 GMT) Full text and rfc822 format available.

Added tag(s) patch. Request was from intrigeri <intrigeri@debian.org> to control@bugs.debian.org. (Sat, 30 Jun 2012 07:48:49 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Kees Cook <kees@debian.org>:
Bug#679597; Package apparmor. (Sun, 01 Jul 2012 22:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to intrigeri <intrigeri@debian.org>:
Extra info received and forwarded to list. Copy sent to Kees Cook <kees@debian.org>. (Sun, 01 Jul 2012 22:06:03 GMT) Full text and rfc822 format available.

Message #22 received at 679597@bugs.debian.org (full text, mbox):

From: intrigeri <intrigeri@debian.org>
To: John Johansen <john.johansen@canonical.com>
Cc: 679597@bugs.debian.org, Kees Cook <kees@ubuntu.com>, control@bugs.debian.org
Subject: Re: Bug#679597: apparmor: AppArmor totally broken
Date: Mon, 02 Jul 2012 00:02:06 +0200
tags 679597 + patch
thanks

Hi,

John Johansen wrote (30 Jun 2012 07:30:20 GMT) :
> Fix the parser so it checks for the presence of the network feature in the
> compatibility interface. Previously it was assuming that if the compatibility
> interface was present that network rules where also present, this is not
> necessarily true and causes apparmor to break when only the compatibility
> patch is applied.

Thanks for this patch.

It works fine for me with the current sid kernel
(linux-image-3.2.0-3-amd64 3.2.21-3).

However, on a kernel that both the compat + network patches applied
(that is, not the current sid kernel), installing the apparmor
userspace tools with this patch applied results in reloading all
profiles (I guess this is normal postinst operation), which triggers
tons of such error messages:

  Warning from /etc/apparmor.d/usr.bin.evince
  (/etc/apparmor.d/usr.bin.evince line 148): profile sanitized_helper
  network rules not enforced

And then, it seems like the applications covered by these profile are
denied access to the network entirely:

  type=1400 audit(1341176452.889:291): apparmor="DENIED"
  operation="create" parent=1 profile="/usr/sbin/ntpd" pid=6748
  comm="ntpd" family="inet" sock_type="dgram" protocol=0

(I've not tried rebooting and see what happens, though.)

So I'm not too sure the network feature detection was fixed entirely.

But well, in any case, the patch fixes the actual, current bug,
which is great!




Information forwarded to debian-bugs-dist@lists.debian.org, Kees Cook <kees@debian.org>:
Bug#679597; Package apparmor. (Mon, 02 Jul 2012 07:57:20 GMT) Full text and rfc822 format available.

Acknowledgement sent to John Johansen <john.johansen@canonical.com>:
Extra info received and forwarded to list. Copy sent to Kees Cook <kees@debian.org>. (Mon, 02 Jul 2012 07:57:21 GMT) Full text and rfc822 format available.

Message #27 received at 679597@bugs.debian.org (full text, mbox):

From: John Johansen <john.johansen@canonical.com>
To: intrigeri <intrigeri@debian.org>
Cc: 679597@bugs.debian.org, Kees Cook <kees@ubuntu.com>, control@bugs.debian.org
Subject: Re: Bug#679597: apparmor: AppArmor totally broken
Date: Mon, 02 Jul 2012 00:56:34 -0700
On 07/01/2012 03:02 PM, intrigeri wrote:
> tags 679597 + patch
> thanks
> 
> Hi,
> 
> John Johansen wrote (30 Jun 2012 07:30:20 GMT) :
>> Fix the parser so it checks for the presence of the network feature in the
>> compatibility interface. Previously it was assuming that if the compatibility
>> interface was present that network rules where also present, this is not
>> necessarily true and causes apparmor to break when only the compatibility
>> patch is applied.
> 
> Thanks for this patch.
> 
> It works fine for me with the current sid kernel
> (linux-image-3.2.0-3-amd64 3.2.21-3).
> 
> However, on a kernel that both the compat + network patches applied
> (that is, not the current sid kernel), installing the apparmor
> userspace tools with this patch applied results in reloading all
> profiles (I guess this is normal postinst operation), which triggers
> tons of such error messages:
> 
>   Warning from /etc/apparmor.d/usr.bin.evince
>   (/etc/apparmor.d/usr.bin.evince line 148): profile sanitized_helper
>   network rules not enforced
> 
> And then, it seems like the applications covered by these profile are
> denied access to the network entirely:
> 
>   type=1400 audit(1341176452.889:291): apparmor="DENIED"
>   operation="create" parent=1 profile="/usr/sbin/ntpd" pid=6748
>   comm="ntpd" family="inet" sock_type="dgram" protocol=0
> 
> (I've not tried rebooting and see what happens, though.)
> 
> So I'm not too sure the network feature detection was fixed entirely.
> 
> But well, in any case, the patch fixes the actual, current bug,
> which is great!
> 

Gah, yes I didn't test this patch in the case of a kernel without the
networking patch followed by a kernel with it.

What is happening is it is applying the check against both the kernel
and cached policy feature set, and turning off networking based on
what is stored in the cached policy. Which in turn causes it to generate
the new cache without networking support. The only way to fix this with
the original patch is to remove the cache and then regenerate it.
Sorry about that

The check just needs to be moved a little. The initial patch should be
reversed and the following patch should be applied. With the caveat that
I haven't had a chance to finish testing it yet.  Though I should have
that done in a few hours.


=== modified file 'parser/parser_main.c'
--- parser/parser_main.c	2012-07-01 08:35:05 +0000
+++ parser/parser_main.c	2012-07-02 07:49:14 +0000
@@ -1187,7 +1182,12 @@
 		write_cache = 0;
 		skip_read_cache = 1;
 		return;
-	}
+	} else if (strstr(flags_string, "network"))
+		kernel_supports_network = 1;
+	else
+		kernel_supports_network = 0;
+
+
 
 	/*
          * Deal with cache directory versioning:







Information forwarded to debian-bugs-dist@lists.debian.org, Kees Cook <kees@debian.org>:
Bug#679597; Package apparmor. (Tue, 03 Jul 2012 03:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to intrigeri <intrigeri@debian.org>:
Extra info received and forwarded to list. Copy sent to Kees Cook <kees@debian.org>. (Tue, 03 Jul 2012 03:06:04 GMT) Full text and rfc822 format available.

Message #32 received at 679597@bugs.debian.org (full text, mbox):

From: intrigeri <intrigeri@debian.org>
To: John Johansen <john.johansen@canonical.com>
Cc: 679597@bugs.debian.org
Subject: Re: Bug#679597: apparmor: AppArmor totally broken
Date: Tue, 03 Jul 2012 05:02:32 +0200
John Johansen wrote (02 Jul 2012 07:56:34 GMT) :
> The check just needs to be moved a little. The initial patch should be
> reversed and the following patch should be applied. With the caveat that
> I haven't had a chance to finish testing it yet.  Though I should have
> that done in a few hours.

I've tested the new (second) patch on both these two kernels (current
sid kernel and a bit older one with the network control patch
applied), and did not experience any weird behaviour this time.




Marked as found in versions apparmor/2.7.103-2. Request was from intrigeri <intrigeri@debian.org> to control@bugs.debian.org. (Sat, 14 Jul 2012 18:12:14 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Kees Cook <kees@debian.org> to control@bugs.debian.org. (Mon, 16 Jul 2012 20:30:03 GMT) Full text and rfc822 format available.

Reply sent to Kees Cook <kees@debian.org>:
You have taken responsibility. (Tue, 17 Jul 2012 17:03:05 GMT) Full text and rfc822 format available.

Notification sent to intrigeri@debian.org:
Bug acknowledged by developer. (Tue, 17 Jul 2012 17:03:05 GMT) Full text and rfc822 format available.

Message #41 received at 679597-close@bugs.debian.org (full text, mbox):

From: Kees Cook <kees@debian.org>
To: 679597-close@bugs.debian.org
Subject: Bug#679597: fixed in apparmor 2.7.103-4
Date: Tue, 17 Jul 2012 17:02:13 +0000
Source: apparmor
Source-Version: 2.7.103-4

We believe that the bug you reported is fixed in the latest version of
apparmor, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 679597@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Kees Cook <kees@debian.org> (supplier of updated apparmor package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Mon, 16 Jul 2012 11:52:42 -0700
Source: apparmor
Binary: apparmor apparmor-utils apparmor-profiles apparmor-docs libapparmor-dev libapparmor1 libapparmor-perl libapache2-mod-apparmor libpam-apparmor apparmor-notify python-libapparmor dh-apparmor
Architecture: source amd64 all
Version: 2.7.103-4
Distribution: unstable
Urgency: low
Maintainer: Kees Cook <kees@debian.org>
Changed-By: Kees Cook <kees@debian.org>
Description: 
 apparmor   - User-space parser utility for AppArmor
 apparmor-docs - Documentation for AppArmor
 apparmor-notify - AppArmor notification system
 apparmor-profiles - Profiles for AppArmor Security policies
 apparmor-utils - Utilities for controlling AppArmor
 dh-apparmor - AppArmor debhelper routines
 libapache2-mod-apparmor - changehat AppArmor library as an Apache module
 libapparmor-dev - AppArmor development libraries and header files
 libapparmor-perl - AppArmor library Perl bindings
 libapparmor1 - changehat AppArmor library
 libpam-apparmor - changehat AppArmor library as a PAM module
 python-libapparmor - AppArmor library Python bindings
Closes: 679597
Changes: 
 apparmor (2.7.103-4) unstable; urgency=low
 .
   * debian/apparmor-profiles.dirs: add directories we might collide
     with apparmor on during purge.
   * debian/patches/fix-network-rule-support.patch: handle lack of
     networking features correctly (Closes: 679597).
Checksums-Sha1: 
 cad3000b8d25ed9191512159024f10e3d9afd67b 2636 apparmor_2.7.103-4.dsc
 41e418b293892870a2d465dca5e030f241d159de 68803 apparmor_2.7.103-4.debian.tar.gz
 bf28a3a738f12e93865cc3967c964ffcdc505971 390832 apparmor_2.7.103-4_amd64.deb
 3badab684a159aad6bbbdb384ab553f7041b5c92 136240 apparmor-utils_2.7.103-4_amd64.deb
 26870cf473d24d363bd844a4e32febb4aedb84d0 48436 libapparmor-dev_2.7.103-4_amd64.deb
 f57c0f309148c4320b5fba0f8923b72858cc10df 58748 libapparmor1_2.7.103-4_amd64.deb
 77e7fd52523722c19e3acf84c37e0a3c63438b0b 57446 libapparmor-perl_2.7.103-4_amd64.deb
 a163a6ea8a3bea9f0ad51d1723ec8135793c1424 36452 libapache2-mod-apparmor_2.7.103-4_amd64.deb
 acc5f65963bba3ce42542bcbb4c3e987a3694ef3 32200 libpam-apparmor_2.7.103-4_amd64.deb
 44f865a2f2cb655bcf17fced738cb4e48869435e 52104 python-libapparmor_2.7.103-4_amd64.deb
 a04fa5b1ab90601e0ef04dadae926962ae6eddee 58128 apparmor-profiles_2.7.103-4_all.deb
 9b7e563fa42571c5cb8ef6e8a0d20c08e5f2f9cc 254726 apparmor-docs_2.7.103-4_all.deb
 0e878fb618c797c8fb5bdfc241aaaa08ed51201e 36536 apparmor-notify_2.7.103-4_all.deb
 8fac42c261479d07d41cc80f0c52095425f02cd2 30314 dh-apparmor_2.7.103-4_all.deb
Checksums-Sha256: 
 863fcc923d7c49a2ed171ea879e3020a4e1396019a347c700bd90f3c1211412c 2636 apparmor_2.7.103-4.dsc
 e2f4cfc1fb496b11c1b1b4ca297444a5ccafce1d19dde8ce2ba072689b632442 68803 apparmor_2.7.103-4.debian.tar.gz
 9b05a22f70381185a9fdd8f6c9c23eaea0e08ee9423b88122bb5d07d451cbe61 390832 apparmor_2.7.103-4_amd64.deb
 9d3af4a24113bd9f5828f40bf9686aba868f1fde79a69300476ee21331e8397b 136240 apparmor-utils_2.7.103-4_amd64.deb
 539c8b546416f85ce5b701a87519953321c71791f337614483773e0a9cda8d10 48436 libapparmor-dev_2.7.103-4_amd64.deb
 b26dec6903586ca118b8006b1dcb43745ec084055042de172d31be86573288a7 58748 libapparmor1_2.7.103-4_amd64.deb
 f1eb5fcfe6b68efd7b4f0337a773c2ced56b188c75f90c950f816ea2ab566fde 57446 libapparmor-perl_2.7.103-4_amd64.deb
 54801091bce316950d191436856a946faba8a2e84fbc21380507f4049cdd4548 36452 libapache2-mod-apparmor_2.7.103-4_amd64.deb
 1c336f69b9e0ea032434308e1d359eb1fb440c904e565d14d243104e5f4f318e 32200 libpam-apparmor_2.7.103-4_amd64.deb
 f5a083741f4c817659ef4486ac220e748ee7b26468b59f0edf0dca9956e58f58 52104 python-libapparmor_2.7.103-4_amd64.deb
 4279eaa352518d120dcc83bf48cdc91d4895906dfe530c74c00d3ab274b536f3 58128 apparmor-profiles_2.7.103-4_all.deb
 711417a03af5a247ef6446c74d0c1797a243f12f23822afcce64d1c8e1a39409 254726 apparmor-docs_2.7.103-4_all.deb
 0972314d5a70ef99a1ca36e254f9ba918cabd213b6c3b5a3e99801ce461556f0 36536 apparmor-notify_2.7.103-4_all.deb
 df238d4d4f11f3584c4108b0ba833135b46a7acfccbb7c0f2ae8d84714ac55e8 30314 dh-apparmor_2.7.103-4_all.deb
Files: 
 8acfa27f57c1824fa9de0d38ceb8674b 2636 admin extra apparmor_2.7.103-4.dsc
 842c87b5a813485f4545805e586a5a91 68803 admin extra apparmor_2.7.103-4.debian.tar.gz
 52c5066f9655cdcbf9e5937679e591c1 390832 admin extra apparmor_2.7.103-4_amd64.deb
 023e869a647802b0dc7264b14c29f450 136240 admin extra apparmor-utils_2.7.103-4_amd64.deb
 771f789f2f659c2abefab569e6050747 48436 libdevel extra libapparmor-dev_2.7.103-4_amd64.deb
 fd03e6b1e46d2ce40c2858f27f00784b 58748 libs extra libapparmor1_2.7.103-4_amd64.deb
 27a1d1fa47e27f79d0702607e37f0a18 57446 perl extra libapparmor-perl_2.7.103-4_amd64.deb
 093f56cdae949b16df4e0db7b4a69f24 36452 libs extra libapache2-mod-apparmor_2.7.103-4_amd64.deb
 03630ba54e8499f76fd8182a7c8cf03d 32200 libs extra libpam-apparmor_2.7.103-4_amd64.deb
 8f81e7cfd43e1ba8fbd29b958bc170ec 52104 python extra python-libapparmor_2.7.103-4_amd64.deb
 a22217c68f121cd072223c2481bc1dfb 58128 admin extra apparmor-profiles_2.7.103-4_all.deb
 8a1377412b792ae2ea3e9d6c04cba7ca 254726 doc extra apparmor-docs_2.7.103-4_all.deb
 5655c024d39a358e3009a8c9c8bb1fd0 36536 admin extra apparmor-notify_2.7.103-4_all.deb
 388cc26ae01a36e04a46ad313f274dfc 30314 devel extra dh-apparmor_2.7.103-4_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)
Comment: Kees Cook <kees@outflux.net>

iQIcBAEBCgAGBQJQBGqbAAoJEIly9N/cbcAmDK0QAIJ045GkRi5FaXAotBQHjqVt
4SFe6ewLZgc6VDfPWmCqSmLDL+yof3/B2dAhu84gVmvlWtIlHt9vsPgaltXTZHA7
L0cWtUSZd8e0I11wuBzoocFvMhHY5PenuD7+23VOnOHMhQXul9P+PxHtoAjf1l4s
Qz2eQ5P9PbHXwb08mfxQRY4UT8FkiYecj61plwnuDzGl7Lfi4FgHwPiyaItREuhC
s/ysimpz75I8GVFo/V4FxuH+Gpi5/7hleGxa9WzqyeSpLl0QcKGrSeXa//VfBFJE
gQ+dRWuTZhQ38qOYgIox4toHTBKnnPKrFzBkSs7j+Dw4+/kgcjaiscXULOe2LfDE
Vi/GvpObnnHQqtmfpLbFalrrxifg14HIImg2OpzaEHedxm2F5rVQJd42dvoo/0IX
wzY01zSv6sLb/Oi8fx374aCZGsv8xHLRqRqPUNNpTZZtpZ2uNY2FC9/lhQ4d1rxD
ATo3um7wUcZRBrQcleo1qj53qrTZobEqZ9kXLcCppsVVOkxyVAlJBbobti2Q8Nxw
J04XnBh5nvZhIpJQco8KiSS5dWnwFh/CpJCdCGHd9bnoYIK4YHgcGACT1aHNSm6s
WXKd6ArUvW7OwVIwWy/TB60eAq4I/RAZzcoyVbQckcqzPcyGqsrWR2L7jJi/MSf0
hxyd4CfTSdIjtnte9wnu
=4AxP
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 25 Aug 2012 07:29:06 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 16:15:34 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.